local L = AceLibrary("AceLocale-2.2"):new("Capping")

function Capping:StartAB()
	if not self.abdata then
		self.abdata = {
			["nodes"] = {
				[L["Lumber Mill"]] 	= "Interface\\Icons\\INV_TradeskillItem_01",
				[L["Blacksmith"]]	= "Interface\\Icons\\Trade_BlackSmithing",
				[L["Mine"]] 		= "Interface\\Icons\\Trade_Mining",
				[L["Stables"]] 	= "Interface\\Icons\\Ability_Mount_RidingHorse",
				[L["Farm"]] 		= "Interface\\Icons\\INV_Misc_Food_25",
			},
		}
	end
	self.abdata.lasttick = {
		["alliancescore"] = 0,
		["alliancetime"] = 0,
		["alliancebases"] = 0,
		["hordescore"] = 0,
		["hordetime"] = 0,
		["hordebases"] = 0,
	}
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE", "ABHordeAssault")
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE", "ABAllianceAssault")
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL", "CheckStartTimer")
	self:ScheduleRepeatingEvent("abupdater", self.UpdateScore, 0.2, self)
end

function Capping:ABAllianceAssault()
	for value,icon in pairs(self.abdata.nodes) do
		if string.find(strlower(arg1), strlower(value)) then
			if string.find(arg1, L["has assaulted"]) or string.find(arg1, L["claims the"]) then
				--Initiate a timer w/ value as text string for 60 seconds
				self:StopBar(value)
				self:StartBar(value, 63.5, icon, "Blue")
				return
			elseif string.find(arg1, L["has defended the"]) or string.find(arg1, L["has taken the"]) then
				--clear a timer for value
				self:StopBar(value)
				return
			end
		end
	end
end
				
function Capping:ABHordeAssault()	
	for value,icon in pairs(self.abdata.nodes) do
		if string.find(strlower(arg1), strlower(value)) then
			if string.find(arg1, L["has assaulted"]) or string.find(arg1, L["claims the"]) then
				--Initiate a timer w/ value as text string for 60 seconds
				self:StopBar(value)
				self:StartBar(value, 63.5, icon, "Red")
				return
			elseif string.find(arg1, L["has defended the"]) or string.find(arg1, L["has taken the"]) then
				--clear a timer for value
				self:StopBar(value)
				return
			end
		end
	end
end				
				

-- Final score calculation from La Vendetta Boss Mods

function Capping:UpdateScore()
	self:ABGetScore()
	if self.abdata.updatetime and
	   self.abdata.lasttick.alliancescore < 2000 and 
	   self.abdata.lasttick.hordescore < 2000 and 
	   self.abdata.lasttick.alliancescore + self.abdata.lasttick.hordescore > 0 and 
	   self.abdata.lasttick.alliancebases + self.abdata.lasttick.hordebases > 0 then
	    
		self.abdata.updatetime = false
		self:ABGetNewTimes()
		
	end
end

-- calculates the final score, a bit messy and may need optimizing
function Capping:ABGetNewTimes()
	local ATime = ( (2000 - self.abdata.lasttick.alliancescore) / self:ABResPerSec(self.abdata.lasttick.alliancebases) )
	              - (time() - self.abdata.lasttick.alliancetime)
	local HTime = ( (2000 - self.abdata.lasttick.hordescore) / self:ABResPerSec(self.abdata.lasttick.hordebases) )
	              - (time() - self.abdata.lasttick.hordetime)

	local active, totalTime, elapsed, running = self:CandyBarStatus(self.abdata.finaltext or "asdfblah")
	if HTime < ATime then
		-- Horde is winning
		local AFinalScore = 10 * floor( ((HTime * self:ABResPerSec(self.abdata.lasttick.alliancebases)) 
		                                 + self.abdata.lasttick.alliancescore + 5) / 10 )
		local HFinalScore = 2000

		if active and running then
			if self.abdata.updatebar then
				self:StopBar(self.abdata.finaltext)
				self.abdata.finaltext = string.format(L["wins %d-%d"], HFinalScore, AFinalScore)
				self:StartBar( self.abdata.finaltext, elapsed + HTime, "Interface\\PvPRankBadges\\PvPRankHorde", "Red", nil, true, 
				               string.format(L["Final: %d - %d"], HFinalScore, AFinalScore) )
				self.abdata.updatebar = false
			end
			self:SetCandyBarTimeLeft(self.abdata.finaltext, HTime)
		else
			self.abdata.finaltext = string.format(L["wins %d-%d"], HFinalScore, AFinalScore)
			self:StartBar( self.abdata.finaltext, HTime, "Interface\\PvPRankBadges\\PvPRankHorde", "Red", nil, true, 
			               string.format(L["Final: %d - %d"], HFinalScore, AFinalScore) )
			self.abdata.updatebar = false
		end
	else
		-- Alliance is winning
		local AFinalScore = 2000
		local HFinalScore = 10 * floor( ((ATime * self:ABResPerSec(self.abdata.lasttick.hordebases)) 
		                                 + self.abdata.lasttick.hordescore + 5) / 10 )
		if active and running then
			if self.abdata.updatebar then
				self:StopBar(self.abdata.finaltext)
				self.abdata.finaltext = string.format(L["wins %d-%d"], AFinalScore, HFinalScore)
				self:StartBar( self.abdata.finaltext, elapsed + ATime, "Interface\\PvPRankBadges\\PvPRankAlliance", "Blue", nil, true, 
				               string.format(L["Final: %d - %d"], AFinalScore, HFinalScore) )
				self.abdata.updatebar = false
			end
			self:SetCandyBarTimeLeft(self.abdata.finaltext, ATime)
		else
			self.abdata.finaltext = string.format(L["wins %d-%d"], AFinalScore, HFinalScore)
			self:StartBar( self.abdata.finaltext, ATime, "Interface\\PvPRankBadges\\PvPRankAlliance", "Blue", nil, true, 
			               string.format(L["Final: %d - %d"], AFinalScore, HFinalScore) )
			self.abdata.updatebar = false
		end
	end
end

function Capping:ABResPerSec(bases)
	bases = tonumber(bases)
	local value = 0.0
	if bases == 1 then value = 0.8333		-- 25 res per 30 sec
	elseif bases == 2 then value = 1.1111	-- 33.3 res per 30 sec
	elseif bases == 3 then value = 1.6667	-- 50 res per 30 sec
	elseif bases == 4 then value = 3.3333	-- 100 res per 30 sec
	elseif bases == 5 then value = 30.0	-- 900 res per 30 sec!
	end
	return value
end

function Capping:ABGetScore()
	local _,AScoreboard = GetWorldStateUIInfo(1)
	local _,HScoreboard = GetWorldStateUIInfo(2)
	if not AScoreboard or not HScoreboard then return false end

	local _,_,ABases,AScore = string.find(AScoreboard, L["Bases: (%d+)  Resources: (%d+)/2000"])
	local _,_,HBases,HScore = string.find(HScoreboard, L["Bases: (%d+)  Resources: (%d+)/2000"])
	if not ABases or not AScore or not HBases or not HScore then return false end

	ABases = tonumber(ABases)
	AScore = tonumber(AScore)
	HBases = tonumber(HBases)
	HScore = tonumber(HScore)
	
	if self.abdata.lasttick.alliancebases ~= ABases or self.abdata.lasttick.hordebases ~= HBases then
		self.abdata.lasttick.alliancebases = ABases
		self.abdata.lasttick.hordebases = HBases
		self.abdata.updatebar = true
	end
	if self.abdata.lasttick.alliancescore ~= AScore then
		self.abdata.lasttick.alliancescore = AScore
		self.abdata.lasttick.alliancetime = time()
		self.abdata.updatetime = true
	end
	if self.abdata.lasttick.hordescore ~= HScore then
		self.abdata.lasttick.hordescore = HScore
		self.abdata.lasttick.hordetime = time()
		self.abdata.updatetime = true
	end
end
