local L = AceLibrary("AceLocale-2.2"):new("Capping")

L:RegisterTranslations("enUS", function() return {
	-- battlegrounds
	["Alterac Valley"] = true, 
	["Arathi Basin"] = true, 
	["Warsong Gulch"] = true,
	["Arena"] = true,
	["Eye of the Storm"] = true,

	-- factions
	["Alliance"] = true,
	["Horde"] = true,
	
	-- options menu
	["Enable"] = true,
	["Auto quest turnins"] = true,
	["Enable Alterac Valley automatic quest turnins"] = true,
	["Bar"] = true,
	["Statusbar options"] = true,
	["Font size"] = true,
	["Change statusbar font size"] = true,
	["Width"] = true,
	["Change statusbar width"] = true,
	["Height"] = true,
	["Change statusbar thickness"] = true,
	["Scale"] = true,
	["Change statusbar scale"] = true,
	["Texture"] = true,
	["Statusbar textures"] = true,
	["Other"] = true,
	["Other options"] = true,
	["Auto show map"] = true,
	["Auto show the battlefield minimap on entry"] = true,
	["Map scale"] = true,
	["Change the default scale of the battlefield minimap"] = true,
	["Port Timer"] = true,
	["Enable timers for port expiration"] = true,
	["Wait Timer"] = true,
	["Enable timers for queue wait time"] = true,
	["Show/Hide Anchor"] = true,
	["Show/Hide the bars anchor (can also left-click a statusbar)"] = true,
	["Disable World PVP Map"] = true,
	["Disable the battlefield minimap from showing outside battlegrounds"] = true,
	["Toggle class color"] = true,
	["Enable/disable class color indicators on the scoreboard"] = true,
	["Narrow map mode"] = true,
	["Narrow the battlefield minimap, removing some empty space"] = true,
	["Test"] = true,
	["Start a test bar"] = true,
	["Reverse fill"] = true,
	["Set statusbars to fill up instead of depleting"] = true,
	["Flip growth"] = true,
	["Set objective timers to grow up and misc timers to grow down"] = true,
	["Reposition Scoreboard"] = true,
	["Move the scoreboard to the Capping anchor's CURRENT position"] = true,
	["Battlefield Minimap"] = true,
	["Options for the battlefield minimap"] = true,
	
	
	-- etc timers
	["Port: "] = true, -- bar text for time remaining to port into a bg
	["Queue: "] = true,
	["Battleground Begins"] = true, -- bar text for bg gates opening (why can't they all be the same?)
	["begins in 1 minute"] = true,
	["begin in 1 minute"] = true,
	["1 minute until"] = true,
	["begins in 30 seconds"] = true,
	["begin in 30 seconds"] = true,
	["30 seconds until"] = true,
	["One minute until"] = true,
	["Thirty seconds until"] = true,
	["Fifteen seconds until"] = true,
	["%s - %s remaining"] = true, -- chat message after shift left-clicking a bar
	
	-- AB	
	["Bases: (%d+)  Resources: (%d+)/2000"] = true, -- arathi basin scoreboard
	["Farm"] = true,
	["Lumber Mill"] = true,
	["Blacksmith"] = true,
	["Mine"] = true,
	["Stables"] = true,
	["has assaulted"] = true,
	["claims the"] = true,
	["has taken the"] = true,
	["has defended the"] = true,
	["Final: %d - %d"] = true, -- final score text
	["wins %d-%d"] = true, -- final score chat message
	
	-- WSG
	["was picked up by (.+)!"] = true,
	["was dropped"] = true,
	["captured the"] = true,
	["Flag respawns"] = true,
	["%s's flag carrier: %s (%s)"] = true, -- chat message
	
	-- AV
	 -- NPC
	["Smith Regzar"] = true,
	["Murgot Deepforge"] = true,
	["Primalist Thurloga"] = true,
	["Arch Druid Renferal"] = true,
	["Stormpike Ram Rider Commander"] = true,
	["Frostwolf Wolf Rider Commander"] = true,
	["Wing Commander Jeztor"] = true,
	["Wing Commander Guse"] = true,
	["Wing Commander Mulverick"] = true,
	["Wing Commander Vipore"] = true,
	["Wing Commander Slidore"] = true,
	["Wing Commander Ichman"] = true,
	 -- patterns
	["avunderattack"] = "^([%w ]+) is under attack!  If left unchecked",
	["avtaken"] = "^([%w ]+) was taken by",
	["avdestroyed"] = "^([%w ]+) was destroyed by",
	["The "] = true,
	["Snowfall Graveyard"] = true,
	["Tower"] = true,
	["Bunker"] = true,
	["Upgrade to"] = true, -- the option to upgrade units in AV
	["Wicked, wicked, mortals!"] = true, -- what Ivus says after being summoned
	["Ivus begins moving"] = true,
	["WHO DARES SUMMON LOKHOLAR"] = true, -- what Lok says after being summoned
	["The Ice Lord has arrived!"] = true,
	["Lokholar begins moving"] = true,
	
} end)

-- de translations provided by Farook
L:RegisterTranslations("deDE", function() return {
   -- battlegrounds
   ["Alterac Valley"] = "Alteractal", 
   ["Arathi Basin"] = "Arathibecken", 
   ["Warsong Gulch"] = "Kriegshymnenschlucht",
   ["Arena"] = "Arena",
   ["Eye of the Storm"] = "Auge des Sturms",

   -- factions
   ["Alliance"] = "Allianz",
   ["Horde"] = "Horde",
   
   -- options menu
   ["Enable"] = "Aktivieren",
   ["Auto quest turnins"] = "Autom. Questabgabe",
   ["Enable Alterac Valley automatic quest turnins"] = "Automatische Questabgabe im Alteractal aktivieren",
   ["Bar"] = "Leiste",
   ["Statusbar options"] = "Optionen Statusleiste",
   ["Font size"] = "Schriftgr\195\182\195\159e",
   ["Change statusbar font size"] = "Die Schriftgr\195\182\195\159e der Statusleiste \195\164ndern",
   ["Width"] = "Breite",
   ["Change statusbar width"] = "Die Breite der Statusleiste \195\164ndern",
   ["Height"] = "H\195\182he",
   ["Change statusbar thickness"] = "Die Dicke der Statusleiste \195\164ndern",
   ["Scale"] = "Skalierung",
   ["Change statusbar scale"] = "Die Skalierung der Statusleiste \195\164ndern",
   ["Texture"] = "Textur",
   ["Statusbar textures"] = "Die Textur der Statusleiste",
   ["Other"] = "Anderes",
   ["Other options"] = "Weitere Optionen",
   ["Auto show map"] = "Karte autom. anzeigen",
   ["Auto show the battlefield minimap on entry"] = "Die Schlachtfeld-Minikarte beim Betreten automatisch anzeigen",
   ["Map scale"] = "Kartenskalierung",
   ["Change the default scale of the battlefield minimap"] = "Die Standardskalierung der Schlachtfeld-Minikarte \195\164ndern",
   ["Port Timer"] = "Port Timer",
   ["Enable timers for port expiration"] = "Die Timer f\195\188r den Port-Ablauf aktivieren",
   ["Wait Timer"] = "Wartezeit Timer",
   ["Enable timers for queue wait time"] = "Die Timer f\195\188r BG-Warteschlangen aktivieren",
   ["Show/Hide Anchor"] = "Anker anzeigen/verstecken",
   ["Show/Hide the bars anchor (can also left-click a statusbar)"] = "Den Leistenanker anzeigen/verstecken (auch mit Linksklick auf Statusleiste)",
   ["Disable World PVP Map"] = "PvP-Weltkarte deaktivieren",
   ["Disable the battlefield minimap from showing outside battlegrounds"] = "Die Anzeige der Schlachtfeld-Minikarte au\195\159erhalb von Schlachtfeldern deaktivieren",
   ["Toggle class color"] = "Klassenfarbe an/aus",
   ["Enable/disable class color indicators on the scoreboard"] = "Die Klassenfarbe auf dem Scoreboard aktivieren/deaktivieren",
   ["Narrow map mode"] = "Karte verkleinern",
   ["Narrow the battlefield minimap, removing some empty space"] = "Verkleinern der Schlachtfeld-Minikarte (entfernt leeren Raum)",
   ["Test"] = "Test",
   ["Start a test bar"] = "Testleisten starten",
   ["Reverse fill"] = "F\195\188llung umkehren",
   ["Set statusbars to fill up instead of depleting"] = "Die Statusleisten f\195\188llen sich aufw\195\164rts (nach rechts), nicht umgekehrt (nach links)",
   ["Flip growth"] = "Anstieg umdrehen",
   ["Set objective timers to grow up and misc timers to grow down"] = "Richtet die Ziel-Timer nach oben, und die Misc-Timer nach unten aus",
   ["Reposition Scoreboard"] = "Scoreboard repositionieren",
   ["Move the scoreboard to the Capping anchor's CURRENT position"] = "Richtet das Scoreboard am AKTUELLEN Anker von Capping neu aus",
   ["Battlefield Minimap"] = "Schlachtfeld-Minikarte",
   ["Options for the battlefield minimap"] = "Optionen f\195\188r die Schlachtfeld-Minikarte",
   
   -- etc timers
   ["Port: "] = "Port: ", -- bar text for time remaining to port into a bg
   ["Queue: "] = "Warteschlange: ",
   ["Battleground Begins"] = "Schlachtfeld beginnt", -- bar text for bg gates opening
   ["begins in 1 minute"] = "beginnt in 1 Minute",
   ["begin in 1 minute"] = "Beginn in 1 Minute",
   ["1 minute until"] = "1 Minute bis",
   ["begins in 30 seconds"] = "beginnt in 30 Sekunden",
   ["begin in 30 seconds"] = "Beginn in 30 Sekunden",
   ["30 seconds until"] = "30 Sekunden bis",
   ["%s - %s remaining"] = "%s - %s verbleibend", -- chat message after shift left-clicking a bar
   ["One minute until"] = "Eine Minute bis",
   ["Thirty seconds until"] = "Drei\195\159ig Sekunden bis",
   ["Fifteen seconds until"] = "F\195\188nfzehn Sekunden bis",
   
   -- AB   
   ["Bases: (%d+)  Resources: (%d+)/2000"] = "Basen: (%d+)  Ressourcen: (%d+)/2000", -- arathi basin scoreboard
   ["Farm"] = "Hof",
   ["Lumber Mill"] = "S\195\164gewerk",
   ["Blacksmith"] = "Schmiede",
   ["Mine"] = "Mine",
   ["Stables"] = "St\195\164lle",
   ["has assaulted"] = "angegriffen!",
   ["claims the"] = "besetzt!",
   ["has taken the"] = "eingenommen!",
   ["has defended the"] = "verteidigt!",
   ["Final: %d - %d"] = "Endstand: %d - %d", -- final score text
   ["wins %d-%d"] = " siegt %d-%d", -- final score chat message
   
   -- WSG
   ["was picked up by (.+)!"] = "(.+) hat die Flagge der (%a+) aufgenommen!",
   ["was dropped"] = "fallen lassen!",
   ["captured the"] = "errungen!",
   ["Flag respawns"] = "Die Flaggen werden jetzt wieder an ihren St\195\188tzpunkten aufgestellt.",
   ["%s's flag carrier: %s (%s)"] = "%s's Flaggentr\195\164ger: %s (%s)",    -- === NEEDS TO BE CHECKED ===
   
   
   -- AV
    -- NPC
   ["Smith Regzar"] = "Schmied Regzar",
   ["Murgot Deepforge"] = "Murgot Deepforge",                                -- === NEEDS TO BE CHECKED ===
   ["Primalist Thurloga"] = "Primalist Thurloga",
   ["Arch Druid Renferal"] = "Erzdruide Renferal",                           -- === NEEDS TO BE CHECKED ===
   ["Stormpike Ram Rider Commander"] = "Stormpike Ram Rider Commander",      -- === NEEDS TO BE CHECKED ===
   ["Frostwolf Wolf Rider Commander"] = "Frostwolf Wolf Rider Commander",    -- === NEEDS TO BE CHECKED ===
   ["Wing Commander Jeztor"] = "Schwadronskommandant Jeztor",
   ["Wing Commander Guse"] = "Schwadronskommandant Guse",
   ["Wing Commander Mulverick"] = "Schwadronskommandant Mulverick",
   ["Wing Commander Vipore"] = "Schwadronskommandant Vipore",
   ["Wing Commander Slidore"] = "Schwadronskommandant Sildore",
   ["Wing Commander Ichman"] = "Schwadronskommandant Ichman",
   -- patterns
   ["avunderattack"] = "(.+) wird angegriffen.*wird die ", -- === NEEDS TO BE CHECKED ===
   ["avtaken"] = "(.+) wurde von der (.+) eingenommen",                             -- === NEEDS TO BE CHECKED ===
   ["avdestroyed"] = "(.+) wurde von der (.+) zerst\195\182rt",                     -- === NEEDS TO BE CHECKED ===
   ["The "] = "Der ",                                                               -- === NEEDS TO BE CHECKED ===
   ["Snowfall Graveyard"] = "Schneewehenfriedhof",
   ["Tower"] = "Turm",
   ["Bunker"] = "Bunker",
   ["Upgrade to"] = "Upgrade to", -- the option to upgrade units in AV               === NEEDS TO BE CHECKED ===
   ["Wicked, wicked, mortals!"] = "Wicked, wicked, mortals!", -- what Ivus says after being summoned   === NEEDS TO BE CHECKED ===
   ["Ivus begins moving"] = "Ivus setzt sich in Bewegung",
   ["WHO DARES SUMMON LOKHOLAR"] = "WHO DARES SUMMON LOKHOLAR", -- what Lok says after being summoned  === NEEDS TO BE CHECKED ===
   ["The Ice Lord has arrived!"] = "The Ice Lord has arrived!", --                     === NEEDS TO BE CHECKED ===
   ["Lokholar begins moving"] = "Lokholar setzt sich in Bewegung",
   
} end)